/*Class definition: This class extends the Adversary class. It basically represents
 * the Blast-ended Skrewt (Bad guy # 2). Remember a blast-ended skrewt cannot be blinded
 * but can be charmed.
 */
public class BlastEndedSkrewts extends Adversary {
	//You can play with these parameters to make the bad guys even worse!
	int attackIndex = 20;
	int defenceIndex = 15;
	//Setting the name, appearance, x and y coordinates
	public BlastEndedSkrewts(String name, char displaySymbol, int xPos, int yPos) {
		super(name, displaySymbol, xPos, yPos);
	}
	//Returns false if the spell is a blind. It will return true if the spell is a charm
	//It also sets the charmTimer. You can increase the value of the charmTimer to give
	//yourself an undue advantage :)
	@Override
	boolean getSpellCast(Move spell) {
		if (spell == Move.BLIND)
			return false;
		if (spell == Move.CHARM) {
			charmTimer = 5;
			return true;
		}
		return false;
	}
	//Reduces the affect of the charm
	@Override
	void wakeUp() {
		reduceCharm();
	}
	//Reduces the charmTimer
	private void reduceCharm() {
		if (charmTimer > 0)
			charmTimer--;
	}

}
