/*Class description: This class extends GameBaseObject class. All game characters have
 * some amount of health/attackIndex/defenceIndex which is dynamically incremented/decremented
 * as the game progresses. This class also has appropriate accessor and mutator methods for 
 * getting and setting the health/attackIndex/defenceIndex
 */
public class GameCharacter extends GameBaseObject {
	//You can change these parameters to make the game more interesting!
	protected int health = 100; 
	protected int attackIndex = 10;
	protected int defenceIndex = 10;

	protected String name;
	
	public GameCharacter(String name, char displaySymbol, int xPos, int yPos) {
		super(displaySymbol, xPos, yPos);
		this.name = name;
	}

	public String toString() {
		return name + "[H(" + health + "):A(" + attackIndex + "):D("
				+ defenceIndex + ")]";
	}

	public int getHealth() {
		return health;
	}

	public void setHealth(int health) {
		this.health = health;
	}

	public int getAttackIndex() {
		return attackIndex;
	}

	public void setAttackIndex(int attackIndex) {
		this.attackIndex = attackIndex;
	}

	public int getDefenceIndex() {
		return defenceIndex;
	}

	public void setDefenceIndex(int defenceIndex) {
		this.defenceIndex = defenceIndex;
	}

	public int attack() {
		return attackIndex;
	}
	//Reduces the health. This is scaled by the defence index (More defence. Less damage impact/)
	public void processDamage(int damage) {
		health -= (damage * 10) / defenceIndex;

	}
}